#include <bits/stdc++.h>

using namespace std;


int main() {
    ifstream cin("drum.in");
    ofstream cout("drum.out");
    constexpr int mod = 1e9 + 7, maxN = 1000000;

    auto lgpow = [&](int base, int exp) {
        int ans = 1;
        while (exp) {
            if (exp & 1)
                ans = 1LL * ans * base % mod;
            base = 1LL * base * base % mod;
            exp >>= 1;
        }
        return ans;
    };

    int fact[maxN + 1] = { 1 }, invFact[maxN + 1] = { 1 };
    for (int i = 1; i <= maxN; ++i)
        fact[i] = 1LL * fact[i - 1] * i % mod;
    invFact[maxN] = lgpow(fact[maxN], mod - 2);
    for (int i = maxN - 1; i >= 1; --i)
        invFact[i] = 1LL * invFact[i + 1] * (i + 1) % mod;
    
    int x0, y0, x1, y1, k;
    cin >> x0 >> y0 >> x1 >> y1 >> k;
    int leftRight = abs(x1 - x0), upDown = (y1 - y0);
    int total = leftRight + upDown;
    int extra = k - total;
    if (k < total || extra % 2 == 1) {
        cout << 0;
        return 0;
    }
    int ans = 0;
    for (int extraUpDown = 0; extraUpDown <= extra; extraUpDown += 2) {
        int up = upDown + extraUpDown / 2;
        int down = extraUpDown / 2;
        int extraLeftRight = extra - extraUpDown;
        int left = leftRight + extraLeftRight / 2;
        int right = extraLeftRight / 2;
        ans = ans + 1LL * fact[k] * invFact[up] % mod * invFact[down] % mod * invFact[left] % mod * invFact[right] % mod;
        if (ans >= mod)
            ans -= mod;
    }
    cout << ans;
}